pipeline {
    agent any

    tools {nodejs "nodejs"}

    stages {
        stage('Pull github') {
            steps {
                git branch: 'main', url: 'https://gitlab.com/nghiephunter.uet.dev/ecommerce'
            }
        }
        stage('Remove old containers') {
            steps {
                sh '''
                    docker rm -f app || true
                '''
            }
        }
        stage('Build and run application') {
            steps {
                sh '''
                    docker build -t laravel .
                    docker run -d -p 80:80 -v ${pwd}:/var/www/html -v $(pwd)/storage/logs:/var/log/nginx -v $(pwd)/nginx:/etc/nginx/conf.d/ --name app laravel
                '''
            }
        }
        stage('Setup laravel') {
            steps {
                sh '''
                    docker exec app composer install
                    docker exec app cp .env.example .env
                    docker exec app php artisan key:generate
                    docker exec app chmod -R 777 storage/
                '''
            }
        }
        stage('Build vueJS') {
            steps {
                sh '''
                    npm install && npm run build
                '''
            }
        }
    }
}
